stages:
  - prepare
  - build
  - build-image
  - deploy

image: harbor.abbos92.uz/java/eclipse-temurin:17-jdk-alpine-cert

variables:
  GRADLE_OPTS: ${GRADLE_OPTS}
  HELM_PATH: helm


.gradle_before_script:
  before_script:
    - export GRADLE_USER_HOME=`pwd`/.gradle

cache:
  key: gradle-caches
  paths:
    - .gradle/wrapper
    - .gradle/caches
  policy: pull

assemble:
  extends:
    - .gradle_before_script
  stage: prepare
  script:
    - ./gradlew assemble
  only:
    changes:
      - "*.gradle"
      - gradle.properties
  cache:
    key: gradle-caches
    paths:
      - .gradle/wrapper
      - .gradle/caches
    policy: push

package:
  extends:
    - .gradle_before_script
  stage: build
  script:
    - ./gradlew clean build
  cache:
    key: gradle-caches
    paths:
      - .gradle/wrapper
      - .gradle/caches
    policy: pull
  artifacts:
    paths:
      - build/libs/*.jar
    when: always
    expire_in: 1 week

## Including sections
include:
  - project: 'abbos92/cicd/pipeline-configs'
    ref: main
    file: 'stages/__dockerBuild.yml'
  - project: 'abbos92/cicd/pipeline-configs'
    ref: main
    file: 'stages/__deploy.yml'
  - project: 'abbos92/cicd/pipeline-configs'
    ref: main
    file: 'stages/__sonarCheck.yml'